Index: palm/trunk/SCRIPTS/mbuild
===================================================================
--- palm/trunk/SCRIPTS/mbuild	(revision 74)
+++ palm/trunk/SCRIPTS/mbuild	(revision 75)
@@ -1395,4 +1395,5 @@
           fi    # ENDE UEBERSETZUNG DER UTILITY-PROGRAMME
 
+          rm -rf  ${remote_host}_last_make_protokoll
 
              # NUR AUF EINEM HLRN-RECHNER UEBERSETZEN
Index: palm/trunk/SCRIPTS/mrun
===================================================================
--- palm/trunk/SCRIPTS/mrun	(revision 74)
+++ palm/trunk/SCRIPTS/mrun	(revision 75)
@@ -2688,8 +2688,14 @@
        # NAMELIST-DATEI MIT WERTEN VON ENVIRONMENT-VARIABLEN ERZEUGEN (ZU
        # LESEN VON PALM)
+       # DAZU VORHER DIE "GLOBAL REVISION" VON SUBVERSION ERMITTELN, FALLS
+       # DIE SOURCEN UNTER SUBVERSION-KONTROLLE STEHEN
+    global_revision=`svnversion $source_path`
+    global_revision="Rev: $global_revision"
+
     cat  >  ENVPAR  <<  %%END%%
  &envpar  run_identifier = '$fname', host = '$localhost',
           write_binary = '$write_binary', tasks_per_node = $tasks_per_node,
-          maximum_cpu_time_allowed = ${cpumax}. /
+          maximum_cpu_time_allowed = ${cpumax}.,
+          revision = '$global_revision' /
 
 %%END%%
Index: palm/trunk/SOURCE/CURRENT_MODIFICATIONS
===================================================================
--- palm/trunk/SOURCE/CURRENT_MODIFICATIONS	(revision 74)
+++ palm/trunk/SOURCE/CURRENT_MODIFICATIONS	(revision 75)
@@ -33,5 +33,5 @@
 Changed:
 -------
-General revision of non-cyclic horizontal boundary conditions: radiation boundary conditions are now used instead of Neumann conditions at the outflow (calculation needs velocity values for t-dt, which are stored on new arrays u_m_l, u_m_r, etc.), calculation of mean outflow is not needed any more, additional gridpoints along x and y (uxrp, vynp) are not needed any more, routine "boundary_conds" now operates on timelevel t+dt and is not split in two parts (main, uvw_outflow) any more, Neumann boundary conditions at inflow/outflow in case of non-cyclic boundary conditions for all 2d-arrays that are handled by exchange_horiz_2d
+General revision of non-cyclic horizontal boundary conditions: radiation boundary conditions are now used instead of Neumann conditions at the outflow (calculation needs velocity values for t-dt, which are stored on new arrays u_m_l, u_m_r, etc.), calculation of mean outflow is not needed any more, volume flow control is added for the outflow boundary (currently only for the north boundary!!), additional gridpoints along x and y (uxrp, vynp) are not needed any more, routine "boundary_conds" now operates on timelevel t+dt and is not split in two parts (main, uvw_outflow) any more, Neumann boundary conditions at inflow/outflow in case of non-cyclic boundary conditions for all 2d-arrays that are handled by exchange_horiz_2d
 
 +age_m in particle_type
@@ -48,9 +48,15 @@
 q is not allowed to become negative (prognostic_equations).
 
+poisfft_init is only called if fft-solver is switched on (init_pegrid).
+
+d3par-parameter moisture renamed to humidity.
+
+Subversion global revision number is read from mrun and added to the run description header and to the run control (_rc) file.
+
 __vtk directives removed from main program.
 
 The uitility routine interpret_config reads PALM environment variables from NAMELIST instead using the system call GETENV.
 
-check_parameters, data_output_dvrp, data_output_ptseries, data_output_ts, exchange_horiz_2d, flow_statistics, header, init_particles, init_pegrid, init_3d_model, modules, palm, package_parin, parin, prognostic_equations, read_3d_binary, time_integration, write_3d_binary
+advec_u_pw, advec_u_up, advec_v_pw, advec_v_up, asselin_filter, check_parameters, coriolis, data_output_dvrp, data_output_ptseries, data_output_ts, data_output_2d, data_output_3d, diffusion_u, diffusion_v, exchange_horiz, exchange_horiz_2d, flow_statistics, header, init_grid, init_particles, init_pegrid, init_rankine, init_pt_anomaly, init_1d_model, init_3d_model, modules, palm, package_parin, parin, poismg, prandtl_fluxes, pres, production_e, prognostic_equations, read_var_list, read_3d_binary, sor, swap_timelevel, time_integration, write_var_list, write_3d_binary
 
 
Index: palm/trunk/SOURCE/advec_particles.f90
===================================================================
--- palm/trunk/SOURCE/advec_particles.f90	(revision 74)
+++ palm/trunk/SOURCE/advec_particles.f90	(revision 75)
@@ -9,5 +9,6 @@
 ! + user_advec_particles, particles-package is now part of the defaut code,
 ! array arguments in sendrecv calls have to refer to first element (1) due to
-! mpich (mpiI) interface requirements 
+! mpich (mpiI) interface requirements,
+! 2nd+3rd argument removed from exchange horiz
 ! TEST: PRINT statements on unit 9 (commented out)
 !
@@ -662,8 +663,8 @@
 !
 !--    Lateral boundary conditions
-       CALL exchange_horiz( de_dx, 0, 0 )
-       CALL exchange_horiz( de_dy, 0, 0 )
-       CALL exchange_horiz( de_dz, 0, 0 )
-       CALL exchange_horiz( diss,  0, 0 )
+       CALL exchange_horiz( de_dx )
+       CALL exchange_horiz( de_dy )
+       CALL exchange_horiz( de_dz )
+       CALL exchange_horiz( diss  )
 
 !
Index: palm/trunk/SOURCE/advec_u_pw.f90
===================================================================
--- palm/trunk/SOURCE/advec_u_pw.f90	(revision 74)
+++ palm/trunk/SOURCE/advec_u_pw.f90	(revision 75)
@@ -4,5 +4,5 @@
 ! Actual revisions:
 ! -----------------
-! 
+! uxrp eliminated
 !
 ! Former revisions:
@@ -54,5 +54,5 @@
        gu = 2.0 * u_gtrans
        gv = 2.0 * v_gtrans
-       DO  i = nxl, nxr+uxrp
+       DO  i = nxl, nxr
           DO  j = nys, nyn
              DO  k = nzb_u_inner(j,i)+1, nzt
Index: palm/trunk/SOURCE/advec_u_up.f90
===================================================================
--- palm/trunk/SOURCE/advec_u_up.f90	(revision 74)
+++ palm/trunk/SOURCE/advec_u_up.f90	(revision 75)
@@ -4,5 +4,5 @@
 ! Actual revisions:
 ! -----------------
-! 
+! uxrp eliminated
 !
 ! Former revisions:
@@ -53,5 +53,5 @@
 
 
-       DO  i = nxl, nxr+uxrp
+       DO  i = nxl, nxr
           DO  j = nys, nyn
              DO  k = nzb_u_inner(j,i)+1, nzt
Index: palm/trunk/SOURCE/advec_v_pw.f90
===================================================================
--- palm/trunk/SOURCE/advec_v_pw.f90	(revision 74)
+++ palm/trunk/SOURCE/advec_v_pw.f90	(revision 75)
@@ -4,5 +4,5 @@
 ! Actual revisions:
 ! -----------------
-! 
+! vynp eliminated
 !
 ! Former revisions:
@@ -56,5 +56,5 @@
        gv = 2.0 * v_gtrans
        DO  i = nxl, nxr
-          DO  j = nys, nyn+vynp
+          DO  j = nys, nyn
              DO  k = nzb_v_inner(j,i)+1, nzt
                 tend(k,j,i) = tend(k,j,i) - 0.25 * (                           &
Index: palm/trunk/SOURCE/advec_v_up.f90
===================================================================
--- palm/trunk/SOURCE/advec_v_up.f90	(revision 74)
+++ palm/trunk/SOURCE/advec_v_up.f90	(revision 75)
@@ -4,5 +4,5 @@
 ! Actual revisions:
 ! -----------------
-! 
+! vynp eliminated
 !
 ! Former revisions:
@@ -53,5 +53,5 @@
 
        DO  i = nxl, nxr
-          DO  j = nys, nyn+vynp
+          DO  j = nys, nyn
              DO  k = nzb_v_inner(j,i)+1, nzt
 !
Index: palm/trunk/SOURCE/asselin_filter.f90
===================================================================
--- palm/trunk/SOURCE/asselin_filter.f90	(revision 74)
+++ palm/trunk/SOURCE/asselin_filter.f90	(revision 75)
@@ -4,5 +4,5 @@
 ! Actual revisions:
 ! -----------------
-! 
+! moisture renamed humidity
 !
 ! Former revisions:
@@ -72,5 +72,5 @@
           ENDIF
 
-          IF ( ( moisture .OR. passive_scalar )  .AND. &
+          IF ( ( humidity .OR. passive_scalar )  .AND. &
              scalar_advec /= 'bc-scheme' )  THEN
              DO  k = nzb_2d(j,i), nzt+1
@@ -96,5 +96,5 @@
     ENDIF
 
-    IF ( ( moisture .OR. passive_scalar )  .AND. &
+    IF ( ( humidity .OR. passive_scalar )  .AND. &
          scalar_advec /= 'bc-scheme' )  THEN
        q = q + asselin_filter_factor * ( q_p - 2.0 * q + q_m )
Index: palm/trunk/SOURCE/boundary_conds.f90
===================================================================
--- palm/trunk/SOURCE/boundary_conds.f90	(revision 74)
+++ palm/trunk/SOURCE/boundary_conds.f90	(revision 75)
@@ -4,6 +4,7 @@
 ! Actual revisions:
 ! -----------------
-! The "main" part sets conditions for time level t+dt insteat of level t,
-! outflow boundary conditions changed from Neumann to radiation condition
+! The "main" part sets conditions for time level t+dt instead of level t,
+! outflow boundary conditions changed from Neumann to radiation condition,
+! uxrp, vynp eliminated, moisture renamed humidity
 !
 ! Former revisions:
@@ -126,7 +127,7 @@
 !--    Boundary conditions for total water content or scalar,
 !--    bottom and surface boundary (see also temperature)
-       IF ( moisture  .OR.  passive_scalar )  THEN
-!
-!--       Surface conditions for constant_moisture_flux
+       IF ( humidity  .OR.  passive_scalar )  THEN
+!
+!--       Surface conditions for constant_humidity_flux
           IF ( ibc_q_b == 0 ) THEN
              DO  i = nxl-1, nxr+1
@@ -154,9 +155,9 @@
           v_p(:,nys,:) = v_p(:,nys-1,:)
        ELSEIF ( inflow_n ) THEN
-          v_p(:,nyn+vynp,:) = v_p(:,nyn+vynp+1,:)
+          v_p(:,nyn,:) = v_p(:,nyn+1,:)
        ELSEIF ( inflow_l ) THEN
           u_p(:,:,nxl) = u_p(:,:,nxl-1)
        ELSEIF ( inflow_r ) THEN
-          u_p(:,:,nxr+uxrp) = u_p(:,:,nxr+uxrp+1)
+          u_p(:,:,nxr) = u_p(:,:,nxr+1)
        ENDIF
 
@@ -166,254 +167,395 @@
           pt_p(:,nys-1,:)     = pt_p(:,nys,:)
           IF ( .NOT. constant_diffusion     )  e_p(:,nys-1,:) = e_p(:,nys,:)
-          IF ( moisture .OR. passive_scalar )  q_p(:,nys-1,:) = q_p(:,nys,:)
+          IF ( humidity .OR. passive_scalar )  q_p(:,nys-1,:) = q_p(:,nys,:)
        ELSEIF ( outflow_n )  THEN
           pt_p(:,nyn+1,:)     = pt_p(:,nyn,:)
           IF ( .NOT. constant_diffusion     )  e_p(:,nyn+1,:) = e_p(:,nyn,:)
-          IF ( moisture .OR. passive_scalar )  q_p(:,nyn+1,:) = q_p(:,nyn,:)
+          IF ( humidity .OR. passive_scalar )  q_p(:,nyn+1,:) = q_p(:,nyn,:)
        ELSEIF ( outflow_l )  THEN
           pt_p(:,:,nxl-1)     = pt_p(:,:,nxl)
           IF ( .NOT. constant_diffusion     )  e_p(:,:,nxl-1) = e_p(:,:,nxl)
-          IF ( moisture .OR. passive_scalar )  q_p(:,:,nxl-1) = q_p(:,:,nxl)      
+          IF ( humidity .OR. passive_scalar )  q_p(:,:,nxl-1) = q_p(:,:,nxl)
        ELSEIF ( outflow_r )  THEN
           pt_p(:,:,nxr+1)     = pt_p(:,:,nxr)
           IF ( .NOT. constant_diffusion     )  e_p(:,:,nxr+1) = e_p(:,:,nxr)
-          IF ( moisture .OR. passive_scalar )  q_p(:,:,nxr+1) = q_p(:,:,nxr)
+          IF ( humidity .OR. passive_scalar )  q_p(:,:,nxr+1) = q_p(:,:,nxr)
        ENDIF
 
     ENDIF
 
-    IF ( range == 'outflow_uvw' ) THEN
-!
-!--    Radiation boundary condition for the velocities at the respective outflow
-       IF ( outflow_s ) THEN
-!          v(:,nys-1,:) = v(:,nys,:)
-!          w(:,nys-1,:) = 0.0
-!!
-!!--       Compute the mean horizontal wind parallel to and within the outflow
-!!--       wall and use this as boundary condition for u
-!#if defined( __parallel )
-!          CALL MPI_ALLREDUCE( uvmean_outflow_l, uvmean_outflow, nzt-nzb+2, &
-!                              MPI_REAL, MPI_SUM, comm1dx, ierr )
-!          uvmean_outflow = uvmean_outflow / ( nx + 1.0 )
-!#else
-!          uvmean_outflow = uvmean_outflow_l / ( nx + 1.0 )
-!#endif
-!          DO  k = nzb, nzt+1
-!             u(k,nys-1,:) = uvmean_outflow(k)
-!          ENDDO
-       ENDIF
-
-       IF ( outflow_n  .AND.                                                 &
-            intermediate_timestep_count == intermediate_timestep_count_max ) &
-       THEN
-
-          c_max = dy / dt_3d
-
-          DO i = nxl-1, nxr+1
-             DO k = nzb+1, nzt+1
-
-!
-!--             First calculate the phase speeds for u,v, and w
-                denom = u_m_n(k,ny,i,-2) - u_m_n(k,ny-1,i,-2)
-
-                IF ( denom /= 0.0 )  THEN
-                   c_u = -c_max * ( u_m_n(k,ny,i,-1)-u_m_n(k,ny,i,-2) ) / denom
-                   IF ( c_u < 0.0 )  THEN
-                      c_u = 0.0
-                   ELSEIF ( c_u > c_max )  THEN
-                      c_u = c_max
-                   ENDIF
-                ELSE
+!
+!-- Radiation boundary condition for the velocities at the respective outflow
+    IF ( outflow_s  .AND.                                                 &
+         intermediate_timestep_count == intermediate_timestep_count_max ) &
+    THEN
+
+       c_max = dy / dt_3d
+
+       DO i = nxl-1, nxr+1
+          DO k = nzb+1, nzt+1
+
+!
+!--          First calculate the phase speeds for u,v, and w
+             denom = u_m_s(k,0,i) - u_m_s(k,1,i)
+
+             IF ( denom /= 0.0 )  THEN
+                c_u = -c_max * ( u(k,0,i) - u_m_s(k,0,i) ) / denom
+                IF ( c_u < 0.0 )  THEN
+                   c_u = 0.0
+                ELSEIF ( c_u > c_max )  THEN
                    c_u = c_max
                 ENDIF
-
-                denom = v_m_n(k,ny,i,-2) - v_m_n(k,ny-1,i,-2)
-
-                IF ( denom /= 0.0 )  THEN
-                   c_v = -c_max * ( v_m_n(k,ny,i,-1)-v_m_n(k,ny,i,-2) ) / denom
-                   IF ( c_v < 0.0 )  THEN
-                      c_v = 0.0
-                   ELSEIF ( c_v > c_max )  THEN
-                      c_v = c_max
-                   ENDIF
-                ELSE
+             ELSE
+                c_u = c_max
+             ENDIF
+             denom = v_m_s(k,0,i) - v_m_s(k,1,i)
+
+             IF ( denom /= 0.0 )  THEN
+                c_v = -c_max * ( v(k,0,i) - v_m_s(k,0,i) ) / denom
+                IF ( c_v < 0.0 )  THEN
+                   c_v = 0.0
+                ELSEIF ( c_v > c_max )  THEN
                    c_v = c_max
                 ENDIF
-
-                denom = w_m_n(k,ny,i,-2) - w_m_n(k,ny-1,i,-2)
-
-                IF ( denom /= 0.0 )  THEN
-                   c_w = -c_max * ( w_m_n(k,ny,i,-1)-w_m_n(k,ny,i,-2) ) / denom
-                   IF ( c_w < 0.0 )  THEN
-                      c_w = 0.0
-                   ELSEIF ( c_w > c_max )  THEN
-                      c_w = c_max
-                   ENDIF
-                ELSE
+             ELSE
+                c_v = c_max
+             ENDIF
+
+             denom = w_m_s(k,0,i) - w_m_s(k,1,i)
+
+             IF ( denom /= 0.0 )  THEN
+                c_w = -c_max * ( w(k,0,i) - w_m_s(k,0,i) ) / denom
+                IF ( c_w < 0.0 )  THEN
+                   c_w = 0.0
+                ELSEIF ( c_w > c_max )  THEN
                    c_w = c_max
                 ENDIF
-
-!
-!--             Calculate the new velocities
-                u(k,ny+1,i) = u_m_n(k,ny+1,i,-1) - dt_3d * c_u * &
-                              ( u_m_n(k,ny+1,i,-1) - u_m_n(k,ny,i,-1) ) * ddy
-
-                v(k,ny+1,i) = v_m_n(k,ny+1,i,-1) - dt_3d * c_v * &
-                              ( v_m_n(k,ny+1,i,-1) - v_m_n(k,ny,i,-1) ) * ddy
-
-                w(k,ny+1,i) = w_m_n(k,ny+1,i,-1) - dt_3d * c_w * &
-                              ( w_m_n(k,ny+1,i,-1) - w_m_n(k,ny,i,-1) ) * ddy
-
-!
-!--             Swap timelevels for the next timestep
-                u_m_n(k,:,i,-2) = u_m_n(k,:,i,-1)
-                u_m_n(k,:,i,-1) = u(k,ny-1:ny+1,i)
-                v_m_n(k,:,i,-2) = v_m_n(k,:,i,-1)
-                v_m_n(k,:,i,-1) = v(k,ny-1:ny+1,i)
-                w_m_n(k,:,i,-2) = w_m_n(k,:,i,-1)
-                w_m_n(k,:,i,-1) = w(k,ny-1:ny+1,i)
-
-             ENDDO
-          ENDDO
-
-!
-!--       Bottom boundary at the outflow
-          IF ( ibc_uv_b == 0 )  THEN
-             u(nzb,ny+1,:) = -u(nzb+1,ny+1,:) 
-             v(nzb,ny+1,:) = -v(nzb+1,ny+1,:)  
-          ELSE                    
-             u(nzb,ny+1,:) =  u(nzb+1,ny+1,:)
-             v(nzb,ny+1,:) =  v(nzb+1,ny+1,:)
-          ENDIF
-          w(nzb,ny+1,:) = 0.0
-
-!
-!--       Top boundary at the outflow
-          IF ( ibc_uv_t == 0 )  THEN
-             u(nzt+1,ny+1,:) = ug(nzt+1)
-             v(nzt+1,ny+1,:) = vg(nzt+1)
-          ELSE
-             u(nzt+1,ny+1,:) = u(nzt,nyn+1,:)
-             v(nzt+1,ny+1,:) = v(nzt,nyn+1,:)
-          ENDIF
-          w(nzt:nzt+1,ny+1,:) = 0.0
-
-       ENDIF
-
-       IF ( outflow_l ) THEN
-!          u(:,:,nxl-1) = u(:,:,nxl)
-!          w(:,:,nxl-1) = 0.0
-!
-!--       Compute the mean horizontal wind parallel to and within the outflow
-!--       wall and use this as boundary condition for v
-!#if defined( __parallel )
-!          CALL MPI_ALLREDUCE( uvmean_outflow_l, uvmean_outflow, nzt-nzb+2, &
-!                              MPI_REAL, MPI_SUM, comm1dy, ierr )
-!          uvmean_outflow = uvmean_outflow / ( ny + 1.0 )
-!#else
-!          uvmean_outflow = uvmean_outflow_l / ( ny + 1.0 )
-!#endif
-!          DO  k = nzb, nzt+1
-!             v(k,:,nxl-1) = uvmean_outflow(k)
-!          ENDDO    
-!
-       ENDIF
-
-       IF ( outflow_r  .AND.                                                 &
-            intermediate_timestep_count == intermediate_timestep_count_max ) &
-       THEN
-
-          c_max = dx / dt_3d
-
-          DO j = nys-1, nyn+1
-             DO k = nzb+1, nzt+1
-
-!
-!--             First calculate the phase speeds for u,v, and w
-                denom = u_m_r(k,j,nx,-2) - u_m_r(k,j,nx-1,-2)
-
-                IF ( denom /= 0.0 )  THEN
-                   c_u = -c_max * ( u_m_r(k,j,nx,-1)-u_m_r(k,j,nx,-2) ) / denom
-                   IF ( c_u < 0.0 )  THEN
-                      c_u = 0.0
-                   ELSEIF ( c_u > c_max )  THEN
-                      c_u = c_max
-                   ENDIF
-                ELSE
+             ELSE
+                c_w = c_max
+             ENDIF
+
+!
+!--          Calculate the new velocities
+             u_p(k,-1,i) = u(k,-1,i) + dt_3d * c_u * &
+                                       ( u(k,-1,i) - u(k,0,i) ) * ddy
+
+             v_p(k,-1,i) = v(k,-1,i) + dt_3d * c_v * &
+                                       ( v(k,-1,i) - v_m_s(k,0,i) ) * ddy
+
+             w_p(k,-1,i) = w(k,-1,i) + dt_3d * c_w * &
+                                       ( w(k,-1,i) - w(k,0,i) ) * ddy
+
+!
+!--          Save old timelevels for the next timestep
+             u_m_s(k,:,i) = u(k,-1:1,i)
+             v_m_s(k,:,i) = v(k,-1:1,i)
+             w_m_s(k,:,i) = w(k,-1:1,i)
+
+          ENDDO
+       ENDDO
+
+!
+!--    Bottom boundary at the outflow
+       IF ( ibc_uv_b == 0 )  THEN
+          u_p(nzb,-1,:) = -u_p(nzb+1,-1,:) 
+          v_p(nzb,-1,:) = -v_p(nzb+1,-1,:)  
+       ELSE                    
+          u_p(nzb,-1,:) =  u_p(nzb+1,-1,:)
+          v_p(nzb,-1,:) =  v_p(nzb+1,-1,:)
+       ENDIF
+       w_p(nzb,ny+1,:) = 0.0
+
+!
+!--    Top boundary at the outflow
+       IF ( ibc_uv_t == 0 )  THEN
+          u_p(nzt+1,-1,:) = ug(nzt+1)
+          v_p(nzt+1,-1,:) = vg(nzt+1)
+       ELSE
+          u_p(nzt+1,-1,:) = u(nzt,-1,:)
+          v_p(nzt+1,-1,:) = v(nzt,-1,:)
+       ENDIF
+       w_p(nzt:nzt+1,-1,:) = 0.0
+
+    ENDIF
+
+    IF ( outflow_n  .AND.                                                 &
+         intermediate_timestep_count == intermediate_timestep_count_max ) &
+    THEN
+
+       c_max = dy / dt_3d
+
+       DO i = nxl-1, nxr+1
+          DO k = nzb+1, nzt+1
+
+!
+!--          First calculate the phase speeds for u,v, and w
+             denom = u_m_n(k,ny,i) - u_m_n(k,ny-1,i)
+
+             IF ( denom /= 0.0 )  THEN
+                c_u = -c_max * ( u(k,ny,i) - u_m_n(k,ny,i) ) / denom
+                IF ( c_u < 0.0 )  THEN
+                   c_u = 0.0
+                ELSEIF ( c_u > c_max )  THEN
                    c_u = c_max
                 ENDIF
-
-                denom = v_m_r(k,j,nx,-2) - v_m_r(k,j,nx-1,-2)
-
-                IF ( denom /= 0.0 )  THEN
-                   c_v = -c_max * ( v_m_r(k,j,nx,-1)-v_m_r(k,j,nx,-2) ) / denom
-                   IF ( c_v < 0.0 )  THEN
-                      c_v = 0.0
-                   ELSEIF ( c_v > c_max )  THEN
-                      c_v = c_max
-                   ENDIF
-                ELSE
+             ELSE
+                c_u = c_max
+             ENDIF
+
+             denom = v_m_n(k,ny,i) - v_m_n(k,ny-1,i)
+
+             IF ( denom /= 0.0 )  THEN
+                c_v = -c_max * ( v(k,ny,i) - v_m_n(k,ny,i) ) / denom
+                IF ( c_v < 0.0 )  THEN
+                   c_v = 0.0
+                ELSEIF ( c_v > c_max )  THEN
                    c_v = c_max
                 ENDIF
-
-                denom = w_m_r(k,j,nx,-2) - w_m_r(k,j,nx-1,-2)
-
-                IF ( denom /= 0.0 )  THEN
-                   c_w = -c_max * ( w_m_r(k,j,nx,-1)-w_m_n(k,j,nx,-2) ) / denom
-                   IF ( c_w < 0.0 )  THEN
-                      c_w = 0.0
-                   ELSEIF ( c_w > c_max )  THEN
-                      c_w = c_max
-                   ENDIF
-                ELSE
+             ELSE
+                c_v = c_max
+             ENDIF
+
+             denom = w_m_n(k,ny,i) - w_m_n(k,ny-1,i)
+
+             IF ( denom /= 0.0 )  THEN
+                c_w = -c_max * ( w(k,ny,i) - w_m_n(k,ny,i) ) / denom
+                IF ( c_w < 0.0 )  THEN
+                   c_w = 0.0
+                ELSEIF ( c_w > c_max )  THEN
                    c_w = c_max
                 ENDIF
-
-!
-!--             Calculate the new velocities
-                u(k,j,nx+1) = u_m_r(k,j,nx+1,-1) - dt_3d * c_u * &
-                              ( u_m_r(k,j,nx+1,-1) - u_m_r(k,j,nx,-1) ) * ddx
-
-                v(k,j,nx+1) = v_m_r(k,j,nx+1,-1) - dt_3d * c_v * &
-                              ( v_m_r(k,j,nx+1,-1) - v_m_r(k,j,nx,-1) ) * ddx
-
-                w(k,j,nx+1) = w_m_r(k,j,nx+1,-1) - dt_3d * c_w * &
-                              ( w_m_r(k,j,nx+1,-1) - w_m_r(k,j,nx,-1) ) * ddx
-
-!
-!--             Swap timelevels for the next timestep
-                u_m_r(k,j,:,-2) = u_m_r(k,j,:,-1)
-                u_m_r(k,j,:,-1) = u(k,j,nx-1:nx+1)
-                v_m_r(k,j,:,-2) = v_m_r(k,j,:,-1)
-                v_m_r(k,j,:,-1) = v(k,j,nx-1:nx+1)
-                w_m_r(k,j,:,-2) = w_m_r(k,j,:,-1)
-                w_m_r(k,j,:,-1) = w(k,j,nx-1:nx+1)
-
-             ENDDO
-          ENDDO
-
-!
-!--       Bottom boundary at the outflow
-          IF ( ibc_uv_b == 0 )  THEN
-             u(nzb,ny+1,:) = -u(nzb+1,ny+1,:) 
-             v(nzb,ny+1,:) = -v(nzb+1,ny+1,:)  
-          ELSE                    
-             u(nzb,ny+1,:) =  u(nzb+1,ny+1,:)
-             v(nzb,ny+1,:) =  v(nzb+1,ny+1,:)
-          ENDIF
-          w(nzb,ny+1,:) = 0.0
-
-!
-!--       Top boundary at the outflow
-          IF ( ibc_uv_t == 0 )  THEN
-             u(nzt+1,ny+1,:) = ug(nzt+1)
-             v(nzt+1,ny+1,:) = vg(nzt+1)
-          ELSE
-             u(nzt+1,ny+1,:) = u(nzt,nyn+1,:)
-             v(nzt+1,ny+1,:) = v(nzt,nyn+1,:)
-          ENDIF
-          w(nzt:nzt+1,ny+1,:) = 0.0
-
-       ENDIF
+             ELSE
+                c_w = c_max
+             ENDIF
+
+!
+!--          Calculate the new velocities
+             u_p(k,ny+1,i) = u(k,ny+1,i) - dt_3d * c_u * &
+                                           ( u(k,ny+1,i) - u(k,ny,i) ) * ddy
+
+             v_p(k,ny+1,i) = v(k,ny+1,i) - dt_3d * c_v * &
+                                           ( v(k,ny+1,i) - v(k,ny,i) ) * ddy
+
+             w_p(k,ny+1,i) = w(k,ny+1,i) - dt_3d * c_w * &
+                                           ( w(k,ny+1,i) - w(k,ny,i) ) * ddy
+
+!
+!--          Swap timelevels for the next timestep
+             u_m_n(k,:,i) = u(k,ny-1:ny+1,i)
+             v_m_n(k,:,i) = v(k,ny-1:ny+1,i)
+             w_m_n(k,:,i) = w(k,ny-1:ny+1,i)
+
+          ENDDO
+       ENDDO
+
+!
+!--    Bottom boundary at the outflow
+       IF ( ibc_uv_b == 0 )  THEN
+          u_p(nzb,ny+1,:) = -u_p(nzb+1,ny+1,:) 
+          v_p(nzb,ny+1,:) = -v_p(nzb+1,ny+1,:)  
+       ELSE                    
+          u_p(nzb,ny+1,:) =  u_p(nzb+1,ny+1,:)
+          v_p(nzb,ny+1,:) =  v_p(nzb+1,ny+1,:)
+       ENDIF
+       w_p(nzb,ny+1,:) = 0.0
+
+!
+!--    Top boundary at the outflow
+       IF ( ibc_uv_t == 0 )  THEN
+          u_p(nzt+1,ny+1,:) = ug(nzt+1)
+          v_p(nzt+1,ny+1,:) = vg(nzt+1)
+       ELSE
+          u_p(nzt+1,ny+1,:) = u_p(nzt,nyn+1,:)
+          v_p(nzt+1,ny+1,:) = v_p(nzt,nyn+1,:)
+       ENDIF
+       w_p(nzt:nzt+1,ny+1,:) = 0.0
+
+    ENDIF
+
+    IF ( outflow_l  .AND.                                                 &
+         intermediate_timestep_count == intermediate_timestep_count_max ) &
+    THEN
+
+       c_max = dx / dt_3d
+
+       DO j = nys-1, nyn+1
+          DO k = nzb+1, nzt+1
+
+!
+!--          First calculate the phase speeds for u,v, and w
+             denom = u_m_l(k,j,0) - u_m_l(k,j,1)
+
+             IF ( denom /= 0.0 )  THEN
+                c_u = -c_max * ( u(k,j,0) - u_m_r(k,j,0) ) / denom
+                IF ( c_u > 0.0 )  THEN
+                   c_u = 0.0
+                ELSEIF ( c_u < -c_max )  THEN
+                   c_u = -c_max
+                ENDIF
+             ELSE
+                c_u = -c_max
+             ENDIF
+
+             denom = v_m_l(k,j,0) - v_m_l(k,j,1)
+
+             IF ( denom /= 0.0 )  THEN
+                c_v = -c_max * ( v(k,j,0) - v_m_l(k,j,0) ) / denom
+                IF ( c_v < 0.0 )  THEN
+                   c_v = 0.0
+                ELSEIF ( c_v > c_max )  THEN
+                   c_v = c_max
+                ENDIF
+             ELSE
+                c_v = c_max
+             ENDIF
+
+             denom = w_m_l(k,j,0) - w_m_l(k,j,1)
+
+             IF ( denom /= 0.0 )  THEN
+                c_w = -c_max * ( w(k,j,0) - w_m_l(k,j,0) ) / denom
+                IF ( c_w < 0.0 )  THEN
+                   c_w = 0.0
+                ELSEIF ( c_w > c_max )  THEN
+                   c_w = c_max
+                ENDIF
+             ELSE
+                c_w = c_max
+             ENDIF
+
+!
+!--          Calculate the new velocities
+             u_p(k,j,-1) = u(k,j,-1) + dt_3d * c_u * &
+                                       ( u(k,j,-1) - u(k,j,0) ) * ddx
+
+             v_p(k,j,-1) = v(k,j,-1) + dt_3d * c_v * &
+                                       ( v(k,j,-1) - v(k,j,0) ) * ddx
+
+             w_p(k,j,-1) = w(k,j,-1) + dt_3d * c_w * &
+                                       ( w(k,j,-1) - w(k,j,0) ) * ddx
+
+!
+!--          Swap timelevels for the next timestep
+             u_m_l(k,j,:) = u(k,j,-1:1)
+             v_m_l(k,j,:) = v(k,j,-1:1)
+             w_m_l(k,j,:) = w(k,j,-1:1)
+
+          ENDDO
+       ENDDO
+
+!
+!--    Bottom boundary at the outflow
+       IF ( ibc_uv_b == 0 )  THEN
+          u_p(nzb,:,-1) = -u_p(nzb+1,:,-1) 
+          v_p(nzb,:,-1) = -v_p(nzb+1,:,-1)  
+       ELSE                    
+          u_p(nzb,:,-1) =  u_p(nzb+1,:,-1)
+          v_p(nzb,:,-1) =  v_p(nzb+1,:,-1)
+       ENDIF
+       w_p(nzb,:,-1) = 0.0
+
+!
+!--    Top boundary at the outflow
+       IF ( ibc_uv_t == 0 )  THEN
+          u_p(nzt+1,:,-1) = ug(nzt+1)
+          v_p(nzt+1,:,-1) = vg(nzt+1)
+       ELSE
+          u_p(nzt+1,:,-1) = u_p(nzt,:,-1)
+          v_p(nzt+1,:,-1) = v_p(nzt,:,-1)
+       ENDIF
+       w_p(nzt:nzt+1,:,-1) = 0.0
+
+    ENDIF
+
+    IF ( outflow_r  .AND.                                                 &
+         intermediate_timestep_count == intermediate_timestep_count_max ) &
+    THEN
+
+       c_max = dx / dt_3d
+
+       DO j = nys-1, nyn+1
+          DO k = nzb+1, nzt+1
+
+!
+!--          First calculate the phase speeds for u,v, and w
+             denom = u_m_r(k,j,nx) - u_m_r(k,j,nx-1)
+
+             IF ( denom /= 0.0 )  THEN
+                c_u = -c_max * ( u(k,j,nx) - u_m_r(k,j,nx) ) / denom
+                IF ( c_u < 0.0 )  THEN
+                   c_u = 0.0
+                ELSEIF ( c_u > c_max )  THEN
+                   c_u = c_max
+                ENDIF
+             ELSE
+                c_u = c_max
+             ENDIF
+
+             denom = v_m_r(k,j,nx) - v_m_r(k,j,nx-1)
+
+             IF ( denom /= 0.0 )  THEN
+                c_v = -c_max * ( v(k,j,nx) - v_m_r(k,j,nx) ) / denom
+                IF ( c_v < 0.0 )  THEN
+                   c_v = 0.0
+                ELSEIF ( c_v > c_max )  THEN
+                   c_v = c_max
+                ENDIF
+             ELSE
+                c_v = c_max
+             ENDIF
+
+             denom = w_m_r(k,j,nx) - w_m_r(k,j,nx-1)
+
+             IF ( denom /= 0.0 )  THEN
+                c_w = -c_max * ( w(k,j,nx) - w_m_r(k,j,nx) ) / denom
+                IF ( c_w < 0.0 )  THEN
+                   c_w = 0.0
+                ELSEIF ( c_w > c_max )  THEN
+                   c_w = c_max
+                ENDIF
+             ELSE
+                c_w = c_max
+             ENDIF
+
+!
+!--          Calculate the new velocities
+             u_p(k,j,nx+1) = u(k,j,nx+1) - dt_3d * c_u * &
+                                           ( u(k,j,nx+1) - u(k,j,nx) ) * ddx
+
+             v_p(k,j,nx+1) = v(k,j,nx+1) - dt_3d * c_v * &
+                                           ( v(k,j,nx+1) - v(k,j,nx) ) * ddx
+
+             w_p(k,j,nx+1) = w(k,j,nx+1) - dt_3d * c_w * &
+                                           ( w(k,j,nx+1) - w(k,j,nx) ) * ddx
+
+!
+!--          Swap timelevels for the next timestep
+             u_m_r(k,j,:) = u(k,j,nx-1:nx+1)
+             v_m_r(k,j,:) = v(k,j,nx-1:nx+1)
+             w_m_r(k,j,:) = w(k,j,nx-1:nx+1)
+
+          ENDDO
+       ENDDO
+
+!
+!--    Bottom boundary at the outflow
+       IF ( ibc_uv_b == 0 )  THEN
+          u_p(nzb,:,nx+1) = -u_p(nzb+1,:,nx+1) 
+          v_p(nzb,:,nx+1) = -v_p(nzb+1,:,nx+1)  
+       ELSE                    
+          u_p(nzb,:,nx+1) =  u_p(nzb+1,:,nx+1)
+          v_p(nzb,:,nx+1) =  v_p(nzb+1,:,nx+1)
+       ENDIF
+       w_p(nzb,:,nx+1) = 0.0
+
+!
+!--    Top boundary at the outflow
+       IF ( ibc_uv_t == 0 )  THEN
+          u_p(nzt+1,:,nx+1) = ug(nzt+1)
+          v_p(nzt+1,:,nx+1) = vg(nzt+1)
+       ELSE
+          u_p(nzt+1,:,nx+1) = u_p(nzt,:,nx+1)
+          v_p(nzt+1,:,nx+1) = v_p(nzt,:,nx+1)
+       ENDIF
+       w(nzt:nzt+1,:,nx+1) = 0.0
 
     ENDIF
